<?php

namespace App\Http\Controllers\Admin;

use App\Http\Requests\LevelRequest;
use App\Level;
use App\Page;
use Exception;
use App\Language;
use App\PageDescription;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Requests\PageRequest;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class LevelController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/levels';
    /** View folder */
    private $viewDirectory= 'admin.levels.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('levels.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the levels.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Level::latest();

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $levels= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('levels'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('levels.store');
        $head = metaFields('levels', 'add_new', getCurrentLocale()) ?? __('levels.new');

        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param PageRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(LevelRequest $request) :RedirectResponse
    {
        $name = [];
        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $name = array_merge($name, $name_attr);
        }

        Level::create([
            'name' => $name,
        ]);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Level $level
     * @return View
     */
    public function edit(Level $level) :View
    {
        $action= route('levels.update', $level->id);
        $head = metaFields('levels', 'edit', getCurrentLocale()) ?? __('levels.edit');
        return view( $this->viewDirectory.'form', compact('level', 'action', 'head') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param LevelRequest $request
     * @param Level $level
     * @return RedirectResponse|Redirector
     */
    public function update(LevelRequest $request, Level $level) :RedirectResponse
    {
        $name = [];
        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $name = array_merge($name, $name_attr);
        }

        $level->update([
            'name' => $name,
        ]);
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $page = Level::withTrashed()->find($id);
        if ($page) {
            if ($page->deleted_at) {
                $page->forceDelete();
            } else {
                $page->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several levels by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Level::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Level::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $page = Level::withTrashed()->find($id);

        if ($page){
            $page->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several levels by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $levels = Level::whereIn('id', $request->ids)->onlyTrashed();
        if ($levels){
            $levels->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
